// BinarizationDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "ImageTool.h"
#include "BinarizationDlg.h"

#include "DibGeometry.h"
#include "DibSegment.h"

// CBinarizationDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CBinarizationDlg, CDialog)

CBinarizationDlg::CBinarizationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBinarizationDlg::IDD, pParent)
	, m_nThreshold(128)
{

}

CBinarizationDlg::~CBinarizationDlg()
{
}

void CBinarizationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_THRESHOLD_EDIT, m_nThreshold);
	DDX_Control(pDX, IDC_THRESHOLD_SLIDER, m_sliderThreshold);
}


BEGIN_MESSAGE_MAP(CBinarizationDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_THRESHOLD_EDIT, &CBinarizationDlg::OnEnChangeThresholdEdit)
END_MESSAGE_MAP()


// CBinarizationDlg ޽ óԴϴ.

void CBinarizationDlg::SetImage(CDib& dib)
{
	m_DibSrc = dib;
}

void CBinarizationDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	// ׸ ޽ ؼ CDialog::OnPaint()() ȣ ʽÿ.

	CPaintDC dc2(GetDlgItem(IDC_IMAGE_WND));
	m_DibRes.Draw(dc2.m_hDC);
}

BOOL CBinarizationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̴ Ʈ ʱȭѴ.
	m_sliderThreshold.SetRange(0, 255);
	m_sliderThreshold.SetTicFreq(32);
	m_sliderThreshold.SetPageSize(32);
	m_sliderThreshold.SetPos(m_nThreshold);

	//  Ʈ ũ⸦ Ѵ. 
	CWnd* pImageWnd = GetDlgItem(IDC_IMAGE_WND);

	CRect rect;
	pImageWnd->GetClientRect(rect);

	//  Ʈ ũ⿡ ° Է  纻 ũ⸦ Ѵ.
	DibResizeNearest(m_DibSrc, rect.Width(), rect.Height());

	// ȭ    Ѵ.
	m_DibRes = m_DibSrc;
	DibBinarization(m_DibRes, m_nThreshold);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CBinarizationDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// ̵̼ ߻ WM_HSCROLL ޽  ó
	if( m_sliderThreshold.GetSafeHwnd() == pScrollBar->GetSafeHwnd() )
	{
		int nPos = m_sliderThreshold.GetPos();
		m_nThreshold = nPos;
		UpdateData(FALSE);

		//   Ӱ谪 ̿Ͽ ̸  ȭ Ѵ.
		m_DibRes = m_DibSrc;
		DibBinarization(m_DibRes, m_nThreshold);
		Invalidate(FALSE);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CBinarizationDlg::OnEnChangeThresholdEdit()
{
	// TODO:  RICHEDIT Ʈ ,  Ʈ
	// CDialog::OnInitDialog() Լ ϰ  ũ OR Ͽ 
	// ENM_CHANGE ÷׸ Ͽ CRichEditCtrl().SetEventMask() ȣؾ߸
	// ش ˸ ޽ ϴ.

	// Ʈ Ʈѿ ڰ ٲ , ̴ Ʈ ġ Ѵ.
	UpdateData(TRUE);
	m_sliderThreshold.SetPos(m_nThreshold);

	//   Ӱ谪 ̿Ͽ ̸  ȭ Ѵ.
	m_DibRes = m_DibSrc;
	DibBinarization(m_DibRes, m_nThreshold);
	Invalidate(FALSE);
}
